-- try to read in this number :  2.37151309632067E-27 
with text_io;

package body Standard_Floating_Numbers_io is

  package single_float_io is new text_io.float_io(single_float);
  package double_float_io is new text_io.float_io(double_float);

  procedure get ( f : in out single_float ) is
  begin
    single_float_io.get(f);
  end get;

  procedure get ( file : in file_type; f : in out single_float ) is
  begin
    single_float_io.get(file,f);
  end get;

  procedure get ( f : in out double_float ) is
  begin
    double_float_io.get(f);
  end get;

  procedure get ( file : in file_type; f : in out double_float ) is
  begin
    double_float_io.get(file,f);
  end get;

  procedure put ( f : in single_float ) is
  begin
    single_float_io.put(f);
  end put;

  procedure put ( file : in file_type; f : in single_float ) is
  begin
    single_float_io.put(file,f);
  end put;

  procedure put ( f : in double_float ) is
  begin
    double_float_io.put(f);
  end put;

  procedure put ( file : in file_type; f : in double_float ) is
  begin
    double_float_io.put(file,f);
  end put;

  procedure put ( f : in single_float; fore,aft,exp : in natural ) is
  begin
    single_float_io.put(f,fore,aft,exp);
  end put;

  procedure put ( f : in double_float; fore,aft,exp : in natural ) is
  begin
    double_float_io.put(f,fore,aft,exp);
  end put;

  procedure put ( file : in file_type;
                  f : in single_float; fore,aft,exp : in natural ) is
  begin
    single_float_io.put(file,f,fore,aft,exp);
  end put;

  procedure put ( file : in file_type;
                  f : in double_float; fore,aft,exp : in natural ) is
  begin
    double_float_io.put(file,f,fore,aft,exp);
  end put;

  procedure put ( f : in double_float; dp : in natural ) is
  begin
    double_float_io.put(f,dp,dp,dp);
  end put;

  procedure put ( file : in file_type;
                  f : in double_float; dp : in natural ) is
  begin
    double_float_io.put(file,f,dp,dp,dp);
  end put;

end Standard_Floating_Numbers_io;
