with text_io;                        use text_io;
with Bracket_Polynomials;            use Bracket_Polynomials;

package Bracket_Polynomials_io is

-- DESCRIPTION :
--   This package provides output operations for bracket polynomials.

  procedure put ( t : in Bracket_Term );
  procedure put ( file : in file_type; t : in Bracket_Term );

  -- DESCRIPTION :
  --   Writes the term on standard output or on file,
  --   if the file is specified as argument of the procedure.

  procedure put ( p : in Bracket_Polynomial );
  procedure put ( file : in file_type; p : in Bracket_Polynomial );

  -- DESCRIPTION :
  --   Writes the polynomial on standard output or on file,
  --   if the file is specified as argument of the procedure.

end Bracket_Polynomials_io;
