with text_io,integer_io;                 use text_io,integer_io;
with Communications_with_User;           use Communications_with_User;
with Driver_for_SAGBI_Homotopies;
with Driver_for_Pieri_Homotopies;
with Driver_for_Quantum_Pieri;

procedure mainenum is

  m,p,q : natural;
  file : file_type;
  ans : character;

begin
  new_line;
  put_line("Reading the name of the output file.");
  Read_Name_and_Create_File(file);
  new_line;
  put("Give p, dimension of the solution planes : "); get(p);
  put("Give m, the co-dimension so that n = m+p : "); get(m);
  new_line;
  put_line("MENU of Homotopies to solve Enumerative Geometry Problems");
  put_line("  1. SAGBI for intersection hypersurface conditions");
  put_line("  2. Pieri for hypersurface and general co-dimensions");
  put_line("  3. Pieri to compute maps of degree q that produce p-planes");
  put("Type 1, 2 or 3 to select : "); Ask_Alternative(ans,"123");
  case ans is
    when '1' => put(file,"SAGBI Homotopies for m = "); put(file,m,1);
                put(file," and p = "); put(file,p,1); new_line(file);
                Driver_for_SAGBI_Homotopies(file,m+p,p);
    when '2' => put(file,"Pieri Homotopies for m = "); put(file,m,1);
                put(file," and p = "); put(file,p,1); new_line(file);
                Driver_for_Pieri_Homotopies(file,m+p,p);
    when '3' => new_line;
                put("Give q, the degree of the maps : "); get(q);
                put(file,"Quantum Pieri for m = "); put(file,m,1);
                put(file,", p = "); put(file,p,1);
                put(file," and q = "); put(file,q,1); new_line(file);
                Driver_for_Quantum_Pieri(file,m+p,p,q);
    when others => put_line("Option not recognized.  Please try again...");
  end case;
end mainenum;
