with Standard_Complex_Vectors;
with Multprec_Complex_Vectors;

package Multprec_Complex_Vector_Tools is

-- DESCRIPTION :
--   Here are some tools for multi-precision vectors.

  function Create ( v : Standard_Complex_Vectors.Vector )
                  return Multprec_Complex_Vectors.Vector;

  -- DESCRIPTION :
  --   Converts the standard complex vector into a multi-precision vector.

  procedure Set_Size ( v : in out Multprec_Complex_Vectors.Vector;
                       size : in natural );

  -- DESCRIPTION :
  --   Adjusts the size of the numbers in v to the given size.

end Multprec_Complex_Vector_Tools;
