with Standard_Complex_Numbers;
with Multprec_Complex_Numbers;

package Multprec_Complex_Number_Tools is

-- DESCRIPTION :
--   Here are some tools for multi-precision numbers.

  function Create ( c : Standard_Complex_Numbers.Complex_Number )
                  return Multprec_Complex_Numbers.Complex_Number;

  -- DESCRIPTION :
  --   Converts the standard complex number into a multi-precision number.

  procedure Set_Size ( c : in out Multprec_Complex_Numbers.Complex_Number;
                       size : in natural );

  -- DESCRIPTION :
  --   Adjusts the size of the number to the given size.

end Multprec_Complex_Number_Tools;
