with text_io;                            use text_io;

package Standard_Integer_Numbers_io is

-- DESCRIPTION :
--   Definitions of the input/output routines for standard integers.

  procedure get ( file : in file_type; i : in out integer );

  -- DESCRIPTION :
  --   Reads an integer number from file.

  procedure put ( file : in file_type; i : in integer );

  -- DESCRIPTION :
  --   Writes an integer number on file, with no spaces in front.

  procedure put ( file : in file_type; i : in integer; dp : in natural );

  -- DESCRIPTION :
  --   Writes the number on file, using at least dp decimal places.
  --   If the number needs less space in its display,
  --   then blanks are added in front of the number.

end Standard_Integer_Numbers_io;
